package com.gyee.frame.util;

import com.gyee.frame.model.custom.ElementNode;

import java.util.ArrayList;
import java.util.List;


public class TreeUtil {

	
//	private final String ROOT="../pages/warningalert/css/zTreeStyle/img/fj.png";
//	private final String PARENT="../pages/warningalert/css/zTreeStyle/img/fu.png";
//	private final String LEAF="../pages/warningalert/css/zTreeStyle/img/zi.png";
	List<ElementNode> nodes = new ArrayList<ElementNode>();

	public TreeUtil(List<ElementNode> nodes) {

		super();

		this.nodes = nodes;

	}

	/**
	 * 构建JSON树形结构
	 * 
	 * @return
	 */

	public List<ElementNode> buildJSONTree() {

		List<ElementNode> nodeTree = buildTree();
		
		//nodeTree.get(0).setIcon(ROOT);

		//String json = JSON.toJSONString(nodeTree);

		return nodeTree;

	}

	/**
	 * 构建树形结构
	 * 
	 * @return
	 */

	public List<ElementNode> buildTree() {

		List<ElementNode> treeNodes = new ArrayList<ElementNode>();

		List<ElementNode> rootNodes = getRootNodes();

		for (ElementNode rootNode : rootNodes) {

			buildChildNodes(rootNode);

			treeNodes.add(rootNode);

		}

		return treeNodes;

	}

	/**
	 * 递归子节点
	 * 
	 * @param node
	 */

	public void buildChildNodes(ElementNode node) {

		List<ElementNode> children = getChildNodes(node);

		if (!children.isEmpty()) {
			//node.setIcon(PARENT);
			
			for (ElementNode child : children) {

				buildChildNodes(child);

			}
			node.setIsParent(true);
			node.setChildren(children);

		}else
		{
			//node.setIcon(LEAF);
		}

	}

	/**
	 * 获取父节点下所有的子节点
	 *
	 * @param pnode
	 * @return
	 */

	public List<ElementNode> getChildNodes(ElementNode pnode) {

		
		List<ElementNode> childNodes = new ArrayList<ElementNode>();

		for (ElementNode n : nodes) {

			if (pnode.getId().equals(n.getPid())) {

				childNodes.add(n);
				
			}

		}

		return childNodes;

	}

	/**
	 * 判断是否为根节点
	 * 
	 * @return
	 */

	public boolean rootNode(ElementNode node) {

		boolean isRootNode = true;

		for (ElementNode n : nodes) {

			if (StringUtils.notEmp(node.getPid()) && node.getPid().equals(n.getId())) {

				isRootNode = false;

				break;

			}

		}

		return isRootNode;

	}

	/**
	 * 获取集合中所有的根节点
	 * 
	 * @return
	 */

	public List<ElementNode> getRootNodes() {

		List<ElementNode> rootNodes = new ArrayList<ElementNode>();

		for (ElementNode n : nodes) {

			if (rootNode(n)) {

				rootNodes.add(n);
				
			}

		}

		return rootNodes;

	}


}
